/*
 *	Serial communication routines
 *  with lucky serial protocol
 *  working only at 9600, 8 n 1
 *  
 *
 *
 *
 */
#ifndef ___SERIAL
#define ___SERIAL

#include	<htc.h>
#include    "delay.h"
//#include    "arrayB1.h"

#define False 0
#define True  1


#define	BRATE		9600
#define UseString   False
#define MY_ADDRESS 0x35


/*	Transmit and Receive port bits */
#define	TxData		RA0				/* Map TxData to pin */
#define	RxData		RA1				/* Map RxData to pin */
#define	INIT_PORT	TRISA = 0b11111110; // = 1<<7	/* set up I/O direction */



void WPutch(unsigned char c) {
	unsigned char	bitno;

	INIT_PORT;
	TxData = 0;			/* start bit */
	bitno = 12;
	do {
       delay_2Us (43); 
	   if(c & 1)
	      TxData = 1;
	   else
	      TxData = 0;
		  c = (c >> 1) | 0x80;
	} while(--bitno);
    NOP();
}

char WGetch(void) {
	unsigned char	c, bitno;
	for(;;) {
		while(RxData)
			continue;		/* wait for start bit */
        delay_2Us (25); 
		if(RxData)
			continue;		/* twas just noise */
		bitno = 8;
		c = 0;
		do {
            delay_2Us (50); 
			c = (c >> 1) | (RxData << 7);
		} while(--bitno);
		return c;
	}
}
/*
char Getche(void)
{
    char c;
	Putch(c = Getch());
	return c;
}*/


#if (UseString)    
void Puts (unsigned char *s) {
   while (*s)
      Putch (*s++);
}

void puts(const char * s)
{
	while(*s)
	   Putch(*s++);
}
#endif

// Il protocollo prevede comndi nel formato:
//        0      1     2    3     
// stx | vli | type | id | addr | Variable_Data(optional) | crc | etx 

unsigned char WgetCommand (void) {
   unsigned char c, i, checksum;
   i = 0;
   checksum = 0;
/*
   while (c != 2)
      c = Getch ();
*/
   c = Getch ();
   if (c != 2) 
      return c;

   while ((c = Getch()) != 3) {
      if (i == 14) 
         return 1;
      write_Buff (i++, c);
      if (c == 2) 
         i = 0;
   }
   if (read_Buff(0) != i) { // Verifica VLI
      return 3;
   }
   if (read_Buff(1) != 1) { // Not a command
      return 4;
   }

   i--;
   for (c=0; c<i; c++) 
      checksum ^= read_Buff(c);
   while (checksum<5)
      checksum++;
   if (read_Buff(i) != checksum) { // Verifica checksum
      return 5;
   }

   if (read_Buff(3) != MY_ADDRESS) { // Non  per me
      return 6;
   }
   return 0;
}

void sendReply (unsigned char result) {
// Il protocollo prevede comndi nel formato:
//        0    1    2    3     
// stx | vli | 0 | id | addr | Variable_Data(optional) | crc | etx 

// Parte dalla situazione di comando ricevuto
//        0    1    2    3     
// stx | vli | 1 | id | addr | Variable_Data(optional) | crc | etx 

   unsigned char i, checksum, temp, vli;
   vli = read_Buff(0);
   vli--;
   checksum = 0;
//   write_Buff (0, 5);
   write_Buff (1, 0);
   write_Buff (3, result);
   Putch(2);
   for (i=0; i<vli; i++) {
      temp = read_Buff(i);
      Putch (temp);
      checksum ^= temp;
   }   
   while (checksum<5)
      checksum++;
   Putch (checksum);
   Putch (3);

}


void fake (void){
unsigned char c;
c = 0;
   for (;;) {
      Putch (c);
      DelayMs (250);
      c++;

   }
}
#endif


