;----------------------------------------------------------------------------------------------
;
;    routines RX e TX RS232         19 gennaio 2009
;
;  da ricordare: 
;  1. le define in top al codice servono per le impostazioni hardware e di veloct
;  2. potrebbe essere da fare aggiustamenti sul return: qui  implementata con il return, 
;      capire se  necessario retlw, con le relative modifche nel codice. 
;      nel caso, la nuova versione avr dei #if per permettere la portabilit del codice
;
;
;----------------------------------------------------------------------------------------------
;   Vanno dichiarate in c:
;
;   extern  void Putch (unsigned char p);
;   extern  unsigned char Getch();
;
;----------------------------------------------------------------------------------------------


#define TX_pin 0
#define TX_port PORTA
#define RX_pin 1
#define RX_port PORTA

#define MYADDRESS 0x35

; i seguenti valori determinao il baudrate: 
;  Baud  clock  bit_delay  half_delay
;  9600   8Mhz    0x32       0x19

#define bit_delay 0x32
#define half_delay 0x20



PSECT text,class=CODE,local,delta=2
GLOBAL _Putch
GLOBAL ??_Putch
FNSIZE _Putch, 3, 1
#include <aspic.h>

#define Par ??_Putch
#define Tmp ??_Putch+2
#define Bitn ??_Putch+1
_Putch:
   movwf	Par
   movlw	0x0c
   movwf	Bitn
   bcf 		TX_port, TX_pin
loop:

						; delay 1 bit
   movlw 	bit_delay 
   movwf	Tmp
  delay:
   nop
   decfsz	Tmp, f
   goto delay
   						 ; copia il bit in uscita (ultimo bit dx)
   btfss	Par, 0 		 ; skip if set
   goto		set0
  set1:
   bsf 		TX_port, TX_pin
   goto		cont
  set0:
   bcf 		TX_port, TX_pin
  cont:
						; ruota a dx il byte, mettendo a 1 il pi a sx
   bsf 		STATUS, 0
   rrf		Par, f
   decfsz	Bitn, f
   goto 	loop

   bcf 		STATUS, 5
   bcf 		STATUS, 6
   return


PSECT text,class=CODE,local,delta=2
GLOBAL _Getch
GLOBAL ??_Getch, ?_Getch
FNSIZE _Getch, 3, 1

#define Retv ??_Getch
#define Temp ??_Getch+2
#define Bitno ??_Getch+1


_Getch:
   clrf		Retv
;   movlw    0x32
;   movwf    Temp
  Start:
;   decf     Temp, f
;   btfsc    STATUS, 2
;   goto     Uscita
   btfsc	RX_port, RX_pin
   goto		Start
									; delay mezzo bit
   movlw 	half_delay 
   movwf	Temp
  delay1:
   nop
   decfsz	Temp, f
   goto 	delay1
									;  disturbo sulla linea: accapo!
   btfsc	RX_port, RX_pin
   goto		_Getch
   movlw 	0x08
   movwf	Bitno
	
  bitRx:								; delay 1 bit intero
   movlw 	bit_delay 
   movwf	Temp
  delay2:
   nop
   decfsz	Temp, f
   goto 	delay2

   bcf		STATUS, 0
   btfsc    RX_port, RX_pin
   bsf		STATUS, 0
   rrf		Retv, f
									;finito?
   decfsz	Bitno, f  
   goto	  	bitRx
  Uscita:
   movf		Retv, w

   bcf 		STATUS, 5
   bcf 		STATUS, 6
return


GLOBAL _GetCommand
GLOBAL ??_GetCommand
GLOBAL _write_Buff, ?_write_Buff, _read_Buff

FNSIZE _GetCommand, 3, 1
#define GTemp ??_GetCommand
#define Gcont ??_GetCommand+1
#define GChek ??_GetCommand+2

_GetCommand:
   clrf		Gcont
   clrf 	GChek
   call		_Getch
   xorlw	0x02
   btfss  	STATUS, 2
   goto 	GFine
Leggo:
   call 	_Getch
   movwf 	?_write_Buff
   xorlw	0x03
   btfsc	STATUS, 2
   goto		Verifiche
   movf		Gcont, w
   call 	_write_Buff
   incf 	Gcont, f
   movlw	0x0c
   xorwf	Gcont, w
   btfsc	STATUS, 2
   goto 	GFine
   goto 	Leggo
Verifiche:
                            ; Verifica VLI (i=read_Buff(0)
   clrw
   call		_read_Buff
   xorwf	Gcont, w
   btfss	STATUS, 2
   goto 	GFine
VerCommand:
   movlw	0x01
   call 	_read_Buff
   xorlw	0x01
   btfss  	STATUS, 2
   goto		GFine
VerChecksum:
   decf		Gcont, f
   clrf		GTemp
   clrf 	GChek
Gciclo:                         ;  0 --> Temp(++) --> Cont
   movf		GTemp, w
   call 	_read_Buff
   xorwf	GChek, f

   incf 	GTemp, f
   movf		Gcont, w
   xorwf 	GTemp, w
   btfss	STATUS, 2
   goto 	Gciclo

   movlw	0x05
   subwf	GChek, w
   btfsc	STATUS, 0
   goto 	fineCHK    ; f>=w  --> C=1  
   movlw 	0x05
   movwf	GChek
fineCHK:
   movf		Gcont, w
   call		_read_Buff
   xorwf	GChek, w
   btfss	STATUS, 2
   goto		GFine
VerAddress: 
   movlw	0x03
   call		_read_Buff
   xorlw	MYADDRESS
GFine:	
   return